var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../App", "../di/DISingleton", "../di/Inject"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    var App_1 = require("../App");
    var DISingleton_1 = require("../di/DISingleton");
    var Inject_1 = require("../di/Inject");
    var CacheService = /** @class */ (function () {
        function CacheService(app) {
            this.app = app;
            this.cache = {};
        }
        CacheService.prototype.remove = function (key) {
            var v = this.cache[key];
            if (v) {
                this.clear(v);
                return v.value;
            }
            return null;
        };
        CacheService.prototype.getOrCreate = function (key, task) {
            return __awaiter(this, void 0, void 0, function () {
                var c, v, e_1;
                var _this = this;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            c = this.cache[key] || (this.cache[key] = {
                                key: key,
                                finalTTL: 3600
                            });
                            if (!c.value) {
                                c.value = task(c);
                            }
                            v = null;
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 3, , 4]);
                            return [4 /*yield*/, c.value];
                        case 2:
                            v = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            e_1 = _a.sent();
                            this.clear(c);
                            throw e_1;
                        case 4:
                            if (c.ttlSeconds !== undefined) {
                                if (typeof c.ttlSeconds === "number") {
                                    c.finalTTL = c.ttlSeconds;
                                }
                                else {
                                    c.finalTTL = c.ttlSeconds(v);
                                }
                            }
                            if (c.timeout) {
                                clearTimeout(c.timeout);
                            }
                            if (c.finalTTL) {
                                this.cache[key] = c;
                                c.timeout = setTimeout(function () {
                                    c.timeout = 0;
                                    _this.clear(c);
                                }, c.finalTTL * 1000);
                            }
                            else {
                                // this is the case where we do not want to store
                                this.clear(c);
                            }
                            return [4 /*yield*/, c.value];
                        case 5: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        CacheService.prototype.clear = function (ci) {
            if (ci.timeout) {
                clearTimeout(ci.timeout);
                ci.timeout = 0;
            }
            this.cache[ci.key] = null;
            delete this.cache[ci.key];
        };
        CacheService = __decorate([
            DISingleton_1.default(),
            __param(0, Inject_1.Inject),
            __metadata("design:paramtypes", [App_1.App])
        ], CacheService);
        return CacheService;
    }());
    exports.default = CacheService;
});
//# sourceMappingURL=CacheService.js.map